/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.sendaAmigo;

import com.rjconsultores.ventaboletos.entidad.ParamCompraPunto;
import com.rjconsultores.ventaboletos.service.ParamCompraPuntoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextboxDecimal;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.zkoss.zk.ui.Component;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Doublebox;

/**
 *
 * @author Rafius
 */
@Controller("editarParamCompraPuntoController")
@Scope("prototype")
public class EditarParamCompraPuntoController extends MyGenericForwardComposer {

    @Autowired
    private ParamCompraPuntoService paramCompraPuntoService;
    private ParamCompraPunto paramCompraPunto;
    private MyListbox paramCompraPuntoList;
    private static Logger log = Logger.getLogger(EditarParamCompraPuntoController.class);
    private Datebox fecInicio;
    private BusquedaParamCompraPuntoController busquedaParamCompraPuntoController;
    private Datebox fecFinal;
    private Button btnApagar;
    private MyTextboxDecimal valorCosto;

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);
        busquedaParamCompraPuntoController = (BusquedaParamCompraPuntoController) Executions.getCurrent().getArg().get("busquedaParamCompraPuntoController");
        paramCompraPunto = (ParamCompraPunto) Executions.getCurrent().getArg().get("paramCompraPunto");
        paramCompraPuntoList = (MyListbox) Executions.getCurrent().getArg().get("paramCompraPuntoList");

        if (paramCompraPunto.getParamcomprapuntoId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        fecInicio.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        fecInicio.getValue();
        fecFinal.getValue();
        valorCosto.getValue();

        List<ParamCompraPunto> lsParam = paramCompraPuntoService.buscar(paramCompraPunto.getFeciniciovigencia(),
                paramCompraPunto.getFecfinvigencia(), null, null);

        boolean podeSalvar = false;

        if (lsParam.isEmpty()) {
            podeSalvar = true;
        } else {
            if (paramCompraPunto.getParamcomprapuntoId() != null) {
                for (ParamCompraPunto p : lsParam) {
                    if (p.getParamcomprapuntoId().equals(paramCompraPunto.getParamcomprapuntoId())) {
                        podeSalvar = true;
                    }
                }
            }
        }

        if (podeSalvar) {
            if (fecInicio.getValue().after(fecFinal.getValue())) {
                
                Messagebox.show(
                        Labels.getLabel("editarParamCompraPuntoController.MSG.busquedaPeriodo"),
                        Labels.getLabel("editarParamCompraPuntoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
                
            } else {
                    paramCompraPunto.setActivo(true);
                    paramCompraPunto.setFecmodif(Calendar.getInstance().getTime());
                    paramCompraPunto.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

                    if (paramCompraPunto.getParamcomprapuntoId() == null) {
                        paramCompraPuntoService.suscribir(paramCompraPunto);
                        paramCompraPuntoList.addItem(paramCompraPunto);
                    } else {
                        paramCompraPuntoService.actualizacion(paramCompraPunto);
                        paramCompraPuntoList.updateItem(paramCompraPunto);
                    }

                    Messagebox.show(
                            Labels.getLabel("editarParamCompraPuntoController.MSG.suscribirOK"),
                            Labels.getLabel("editarParamCompraPuntoController.window.title"),
                            Messagebox.OK, Messagebox.INFORMATION);

                    busquedaParamCompraPuntoController.refreshLista();
                    closeWindow();
            }
        } else {
            Messagebox.show(
                    Labels.getLabel("MSG.Registro.Existe"),
                    Labels.getLabel("editarParamCostoTarjetaController.window.title"),
                    Messagebox.OK, Messagebox.EXCLAMATION);
        }
    }

    public void onClick$btnApagar(Event ev) throws InterruptedException {
        int resp = Messagebox.show(
                Labels.getLabel("editarParamCompraPuntoController.MSG.borrarPergunta"),
                Labels.getLabel("editarParamCompraPuntoController.window.title"),
                Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

        if (resp == Messagebox.YES) {

            paramCompraPuntoService.borrar(paramCompraPunto);

            Messagebox.show(
                    Labels.getLabel("editarParamCompraPuntoController.MSG.borrarOK"),
                    Labels.getLabel("editarParamCompraPuntoController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);

            paramCompraPuntoList.removeItem(paramCompraPunto);

            closeWindow();
        }
    }

    public Datebox getFecFinal() {
        return fecFinal;
    }

    public void setFecFinal(Datebox fecFinal) {
        this.fecFinal = fecFinal;
    }

    public Datebox getFecInicio() {
        return fecInicio;
    }

    public void setFecInicio(Datebox fecInicio) {
        this.fecInicio = fecInicio;
    }

    public ParamCompraPunto getParamCompraPunto() {
        return paramCompraPunto;
    }

    public void setParamCompraPunto(ParamCompraPunto paramCompraPunto) {
        this.paramCompraPunto = paramCompraPunto;
    }

    public MyListbox getParamCompraPuntoList() {
        return paramCompraPuntoList;
    }

    public void setParamCompraPuntoList(MyListbox paramCompraPuntoList) {
        this.paramCompraPuntoList = paramCompraPuntoList;
    }

    public ParamCompraPuntoService getParamCompraPuntoService() {
        return paramCompraPuntoService;
    }

    public void setParamCompraPuntoService(ParamCompraPuntoService paramCompraPuntoService) {
        this.paramCompraPuntoService = paramCompraPuntoService;
    }

}
